
** función SubTotal()

** Parámetros:
**   tCampo  - al que se le mostrará el Total 
**   tSum    - ¿se desea Sum o Count o Promedio(Average)? Los valores son S, C, P(óA), o vacío--->default para SUM
**   tFiltro - es decir el Grupo
** 
** Sintaxis:
**   SubTotal ( 'UNID', 'S', 'ZONA+CLASE+ESP_COD+IDENT' ) 
**   SubTotal ( 'UNID', 'S', 'ZONA+CLASE+ESP_COD' ) 
**   SubTotal ( 'UNID', 'S', 'ZONA+CLASE' ) 
**   SubTotal ( 'UNID', 'S', 'ZONA' ) 
** 
** Requisitos:
**   El alias() actual debe estar ordenado por el Grupo que se desea
**       Ejm: INDEX on ZONA+CLASE+ESP_COD+IDENT TAG indice OF ('csr'+ALIAS())
**   Se espera que no haya un cursor que se llame _SUBTOTALES_ que sea usado por el programador (si lo usas 
**       normalmente en tus desarrollos, te recomiendo que reedites este .PRG para que el cursor lo llames diferente)
**   El subtotal se obtiene del alias actual (pues así funciona un reporte)
** 
** 

**
lparameters M.tFld, M.tSum, M.tFiltro

if pcount()=3
   ** ok...
else
   wait window 'Faltaron parámetros para '+program();
     +chr(13)+'1: '+transform(M.tFld);
     +chr(13)+'2: '+transform(M.tSum);
     +chr(13)+'3: '+transform(M.tFiltro);
     +'' timeout 1
   return 0
endif   

local M.cSQL, M.cFiltro, M.cRet 
M.cRet = 0 && el valor que vamos a obtener es numérico

M.cFiltro = evaluate(M.tFiltro)

M.cSQL = ''
do case
case M.tSum='S' or empty(M.tSum)
   M.cSQL = ' select sum('  +M.tFld+') as _TOTAL from alias() where '+M.tFiltro+' == "'+M.cFiltro+'" into cursor _SUBTOTALES_ nofilter'
case M.tSum='C'
   M.cSQL = ' select count('+M.tFld+') as _TOTAL from alias() where '+M.tFiltro+' == "'+M.cFiltro+'" into cursor _SUBTOTALES_ nofilter'
case M.tSum='P' or M.tSum='A'
   M.cSQL = ' select avg('  +M.tFld+') as _TOTAL from alias() where '+M.tFiltro+' == "'+M.cFiltro+'" into cursor _SUBTOTALES_ nofilter'
endcase

if !empty(M.cSQL)
   wait window M.cSQL nowait noclear
   M.OldSel=select()
   &cSQL
   select(M.OldSel)
endif

if used('_SUBTOTALES_') and reccount('_SUBTOTALES_')>0 and !isnull(_SUBTOTALES_._TOTAL)
   M.cRet = _SUBTOTALES_._TOTAL
endif
wait clear

return M.cRet

**